/*
 * }`LXgMTvvO
 *
 *   LLMNR̃pPbgMāA܂B
 *   ʐM(Windows PC)224.0.0.252̃|[gԍ5355ĂɃpPbg𑗐M܂B
 *   ^[Qbg̓pPbgMāApPbg̓emFĎ̖OłȂA
 *   ^[QbgIPAhXi[ĕԐM܂B
 *   ʐM͕ԐMɊi[ĂIPAhX^[QbgIPAhX𓾂܂B
 *   
 *   LLMNRɂĂ͊ȈՓIȎłB
 *
 *  \[X
 *    ̃\[XRtBO[^œo^ĂB
 *
 *    ^XN(1)
 *       ID              ID_LLMNR_TSK
 *       ^XN̊֐  llmnr_tsk
 *       Dx̏l  4 (KvɉĕύXĂ)
 *       g        Ȃ (͂Ȃ)
 *       ^XN      Ȃ (TA_ACT, TA_RSTRɃ`FbNȂ)
 *       X^bNTCY  768
 *       
 *    \Pbg(1)
 *       ID̒`            ID_SOC_LLMNR
 *       IPo[W          IPv4
 *       vgR            UDP
 *       [J|[g        5355
 *       snd_soc̃^CAEg 1000
 *       rcv_soc̃^CAEg -1
 *
 *   Jn
 *     RtBO[^œo^^XN(ID = ID_LLMNR_TSK)JnĂB
 *     
 *       sta_tsk(ID_LLMNR_TSK, 0);
 *   
 *   mF
 *     
 *     ^[QbgƓLANɐڑĂWindows PC (Windows7ȍ~)A
 *     pingsĉ邱ƂmFĂB
 *
 *       ping TEST_LLMNR
 *
 *     TEST_LLMNR͎#defineŒ`Ă܂B
 *     #define̒`ςꍇping̈ύXĂB
 *
 *         #define NAME      "TEST_LLMNR"
 *
 */
#include "kernel.h"
#include "net_hdr.h"
#include "net_id.h"
#include "net_strlib.h"

/* obt@ */
#define LLMNR_BUF_SZ (256)
UB llmnr_buf[LLMNR_BUF_SZ];

/* Oő咷 */
#define LLMNR_NAME_LEN_MAX (64)

/* O */
#define NAME      "TEST_LLMNR"

/* O(pPbgtH[}bg)i[ */
UB llmnr_pkt_fmt_name[LLMNR_NAME_LEN_MAX + 2];
UH llmnr_pkt_fmt_name_len;

/* wb_TCY */
#define LLMNR_HDR_LEN       (12U)
/* QUESTION SectiñTCY(ŏl) */
#define LLMNR_QSEC_LEN_MIN  (7U)

/* ֐錾 */
static ER llmnr_check_qsec(UB *buf, UINT len);
static ER llmnr_build_res_pkt(UB *buf, UB dev_num, UINT max_len);
static ER llmnr_get_name_pkt_fmt_len(UB *buf, UINT max_len);
static ER llmnr_cnv_name_pkt_fmt(UB *buf, const char *name, UINT name_max_len);

void llmnr_tsk(VP_INT exinf)
{
    UW mcast_ip = ip_aton("224.0.0.252");
    T_NODE remote;
    UH len;
    UH qr;
    UH count;
    ER ercd;
    
    /* }`LXgO[vIPAhXo^ */
    /* p[^R[h NET_MCAST_JOINnet_cfg( )s */
#if 1 /* ̃R[hȂƁAIPAhX̃}`LXgMł܂*/
    ercd = net_cfg(
               ID_NETIF_DEV1,  /* foCXԍ */
               NET_MCAST_JOIN, /* p[^R[h */
               (VP)mcast_ip    /* IPAhX */
           );
    if (ercd != E_OK) {
        return;
    }
#endif
    
    /* OLLMNR̃pPbgŎgptH[}bg֕ϊ */
    ercd = llmnr_cnv_name_pkt_fmt(llmnr_pkt_fmt_name, NAME, LLMNR_NAME_LEN_MAX);
    if (ercd < 0) {
        return;
    }
    
    llmnr_pkt_fmt_name_len = (UH)ercd;
    
    while(1) {
        /* M */
        ercd = rcv_soc(
                   ID_SOC_LLMNR,  /* \PbgʂID */
                   llmnr_buf,     /* Mf[^ւ̃|Cg */
                   LLMNR_BUF_SZ   /* Mf[^TCY     */
               );
        if (ercd < 0) {
            continue;
        }
        
        len = (UH)ercd;
        
        /* M(ʐM)IPAhXE|[gԍ擾 */
        ercd = ref_soc(
                   ID_SOC_LLMNR,  /* \PbgʂID */
                   SOC_IP_REMOTE, /* p[^R[h     */
                   (VP)&remote    /* i[ (T_NODE^)    */
               );
        
        if (len < (LLMNR_HDR_LEN + LLMNR_QSEC_LEN_MIN)) {
            continue;
        }
        
        /* Mf[^mF */
        qr    =  (llmnr_buf[2] << 8) | (llmnr_buf[3]); /* QR, Opcoe, C, TC, T, RCODE */
        
        if ((qr & 0x8000U) != 0U) {
            continue; /* Discard (response packet) */
        }
        
        /* QDCOUNT */
        count =  (llmnr_buf[4] << 8) | (llmnr_buf[5]); /* QDCOUNT */
        if (count != 1) {
            continue; /* Discard */
        }
        
        /* Question sectionmF */
        /*  tH[}bgƖO^[Qbg̖OƈvĂ邩mF */
        ercd = llmnr_check_qsec(
                   llmnr_buf + LLMNR_HDR_LEN, /* Question section̐擪AhX */
                   len - LLMNR_HDR_LEN        /* TCY */
               );
        if (ercd < 0) {
            continue; /* ^[Qbg̖OƈvĂȂ̂ŁAԐMKvȂ */
        }
        
        /* ԐMf[^쐬 */
        ercd = llmnr_build_res_pkt(
                   llmnr_buf,     /* obt@       */
                   remote.num,    /* foCXԍ   */
                   LLMNR_BUF_SZ   /* obt@TCY */
               );
        if (ercd < 0) {
            continue; /* obt@̃TCYȂ */
        }
        
        len = (UH)ercd; /* ԐMf[^ */
        
        /* ԐM */
        /*  ԐMݒ */
        ercd = con_soc(
                   ID_SOC_LLMNR, /* \PbgʂID */
                   &remote,      /* [gzXg   */
                   SOC_CLI       /* ڑ[h           */
               );
        
        ercd = snd_soc(
                   ID_SOC_LLMNR, /* \PbgʂID */
                   llmnr_buf,    /* Mf[^̃|C^ */
                   (UH)len       /* Mf[^TCY     */
               );
    }
}

static ER llmnr_check_qsec(UB *buf, UINT len)
{
    UINT name_len;
    UINT i;
    UB *p1;
    UB *p2;
    UB  c1;
    UB  c2;
    UH  type;
    UH  cls;
    ER  ercd;
    
    /* Question Section format      */
    /*   Offset   Length            */
    /*     0        N       QNAME    */
    /*     N        2       QTYPE    */
    /*     N+2      2       QCLASS   */
    
    /* QNAME̒ */
    ercd = llmnr_get_name_pkt_fmt_len(buf, len - 4U);
    if (ercd < 0) {
        return ercd;
    }
    
    name_len = (UINT)ercd;
    
    /* Or */
    if (name_len != llmnr_pkt_fmt_name_len) {
        return ercd; /* OvȂ (vĂȂ) */
    }
    
    p1 = buf;
    p2 = llmnr_pkt_fmt_name;
    
    for (i = 0U; i < name_len; i++) {
        c1 = *p1;
        c2 = *p2;
        
        if ((c1 >= 'a') && (c1 <= 'z')) {
            c1 = c1 - 'a' + 'A';
        }
        
        if ((c2 >= 'a') && (c2 <= 'z')) {
            c2 = c2 - 'a' + 'A';
        }
        
        if (c1 != c2) {
            return E_OBJ; /* OvȂ */
        }
        
        p1++;
        p2++;
    }
    
    /* TYPEmF */
    /*   Â݂T|[gȂ̏ꍇ͉Ȃ */
    type = (*p1 << 8) | (*(p1+1));
    
    if (type != 0x0001U) {
        return E_OBJ; /* T|[gĂȂTYPE */
    }
    
    p1 += 2;
    
    /* CLASSmF */
    /*  IN(l1)ȊO̓T|[gȂ */
    cls = (*p1 << 8) | (*(p1+1));
    if (cls != 0x0001U) {
        return E_OBJ; /* T|[gĂȂCLASS */
    }
    
    return (ER)(name_len + 4U);
}

static ER llmnr_build_res_pkt(UB *buf, UB dev_num, UINT max_len)
{
    T_NET_ADR net_adr;
    UINT pkt_len;
    UINT ans_len;
    UINT q_len;
    
    /* IPAhX擾 */
    net_ref(dev_num, NET_IP4_CFG, (VP)&net_adr);
    
    /* answer section length */
    ans_len = llmnr_pkt_fmt_name_len /* NAME */
               + 2U                  /* Type  */
               + 2U                  /* Class */
               + 4U                  /* TTL */
               + 2U                  /* RDLENGTH */
               + 4U                  /* RDATA (A) */
              ;
    q_len  = llmnr_pkt_fmt_name_len  /* QNAME  */
               + 2U                  /* QTYPE  */
               + 2U                  /* QCLASS */
             ;
    
    pkt_len = LLMNR_HDR_LEN + q_len + ans_len;
    if (pkt_len > max_len) {
        return E_NOMEM;
    }
    
    /* ID = Mf[^Ɠ */
    /* *(buf + 0) = *(buf + 0) */
    /* *(buf + 1) = *(buf + 1) */
    
    /* QR, Opcode, C, TC, T, RCODE, */
    *(buf + 2) |= 0x80U; /* Set QR bit */
    /* *(buf + 3) = *(buf + 3) */
    
    /* QDCOUNT = Mf[^Ɠ  */
    /* *(buf + 4) = *(buf + 4) */
    /* *(buf + 5) = *(buf + 5) */
    
    /* ANCOUNT = 1 */
    *(buf + 6) = 0x00U;
    *(buf + 7) = 0x01U;
    
    /* NSCOUNT = 0 */
    *(buf + 8) = 0x00U;
    *(buf + 9) = 0x00U;
    
    /* ARCOUNT = 0 */
    *(buf + 10) = 0x00U;
    *(buf + 11) = 0x00U;
    
    /* Question section = Mf[^Ɠ */
    
    /* ---- Answer ------*/
    buf += (LLMNR_HDR_LEN + q_len);
    
    /* NAME */
    net_memcpy(buf, llmnr_pkt_fmt_name, llmnr_pkt_fmt_name_len);
    buf += llmnr_pkt_fmt_name_len;
    
    /* TYPE = 0x01 (A) */
    *(buf + 0) = 0x00U;
    *(buf + 1) = 0x01U;
    
    /* CLASS = 0x01 (IN) */
    *(buf + 2) = 0x00U;
    *(buf + 3) = 0x01U;
    
    /* TTL */
    *(buf + 4) = 0U;
    *(buf + 5) = 0U;
    *(buf + 6) = 0U;
    *(buf + 7) = 30U;
    
    /* RDLENGTH 4byte (Length of IP address) */
    *(buf + 8) = 0U;
    *(buf + 9) = 4U;
    
    /* RDATA  (IP Address) */
    *(buf + 10) = (UB)(net_adr.ipaddr >> 24);
    *(buf + 11) = (UB)(net_adr.ipaddr >> 16);
    *(buf + 12) = (UB)(net_adr.ipaddr >>  8);
    *(buf + 13) = (UB) net_adr.ipaddr;
    
    return (ER)pkt_len;
}

static ER llmnr_get_name_pkt_fmt_len(UB *buf, UINT max_len)
{
    UINT l;
    UB   *p;
    UB   label_len;
    
    l = 0;
    p = buf;
    
    while (1) {
        
        label_len = *p;
        
        l += (label_len + 1);
        p += (label_len + 1);
        
        if (label_len == 0U) {
            break;
        }
        
        if (l > max_len) {
            return E_OBJ;
        }
    }
    
    return (ER)l;
}

static ER llmnr_cnv_name_pkt_fmt(UB *buf, const char *name, UINT name_max_len)
{
    UINT l;
    UINT name_len = net_strlen(name);    
    UB *label;
    const char *src;
    UB *dst;
    
    if (name_len > name_max_len) {
        return E_NOMEM;
    }
    
    label = buf;
    dst   = buf + 1;
    src   = name;
    
    while (1) {
        
        for (l = 0; l < 256; l++) {
            if ((*src == '\0') || (*src == '.')) {
                break;
            } else {
                *dst = *src;
                src++;
                dst++;
            }
        }
        
        if ((l == 0U) || (l == 256U)) {
            return E_OBJ;
        }
        
        *label = (UB)l;
        label  = dst;
    
        if (*src == 0x00U) {
            *label = 0U;
            break;
        }
        
        src++;
        dst++;
    }
    
    return name_len + 2;
}

